#import "KpprinterPlugin.h"
#import "KPPrinterSeriesID.h"

@interface KpprinterPlugin ()

@property (strong ,nonatomic) KPPrinterSeriesID *printerSeariesID;

@end

@implementation KpprinterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"kpprinter"
            binaryMessenger:[registrar messenger]];
  KpprinterPlugin* instance = [[KpprinterPlugin alloc] init];
    instance.printerSeariesID = [[KPPrinterSeriesID alloc] init];//可打mtp
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    NSLog(@"call.method:%@",call.method);
    NSString *strMethod = [call.method stringByAppendingString:@":"];
    SEL selector = NSSelectorFromString(strMethod);
    
    if ([self respondsToSelector:selector]) {
        [self performSelector:selector withObject:@{@"call":call,@"result":result}];
    } else {
        result(FlutterMethodNotImplemented);
    }

//  if ([@"getPlatformVersion" isEqualToString:call.method]) {
//    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
//  } else {
//    result(FlutterMethodNotImplemented);
//  }
}



#pragma mark - 搜索
- (void)printer_search:(id)aObject{
    __weak typeof(self) weakself = self;

    NSDictionary *dic = (NSDictionary *)aObject;
    FlutterResult fluresult = dic[@"result"];
    
    [self.printerSeariesID search];
    self.printerSeariesID.searchResult_block = ^(NSDictionary *aDicPrinter) {
        [weakself showText:[NSString stringWithFormat:@"搜索结果：%@",aDicPrinter]];
        fluresult(aDicPrinter);
    };

}

#pragma mark - 连接打印机
- (void)printer_connectAPrinter:(id)aObject{
    __weak typeof(self) weakself = self;

    NSDictionary *dic = (NSDictionary *)aObject;
    FlutterResult fluresult = dic[@"result"];
    FlutterMethodCall *call = dic[@"call"];

    [self.printerSeariesID connectPrinter:call.arguments];
    self.printerSeariesID.connectResult_block = ^(NSString *aStrResult) {
        [weakself showText:[NSString stringWithFormat:@"连接结果：%@",aStrResult]];
        fluresult(aStrResult);
    };

}

#pragma mark - 断开打印机
- (void)printer_disconnectAPrinter:(id)aObject{
    __weak typeof(self) weakself = self;

    NSDictionary *dic = (NSDictionary *)aObject;
    FlutterResult fluresult = dic[@"result"];
    FlutterMethodCall *call = dic[@"call"];

    [self.printerSeariesID disconectPrinter:call.arguments];
    self.printerSeariesID.disconnectResult_block = ^(NSString *aStrResult) {
        [weakself showText:[NSString stringWithFormat:@"断开结果：%@",aStrResult]];
        fluresult(aStrResult);

    };

}

#pragma mark - 打印
- (void)printer_print:(id)aObject{
    __weak typeof(self) weakself = self;

    NSDictionary *dic = (NSDictionary *)aObject;
    FlutterResult fluresult = dic[@"result"];
    FlutterMethodCall *call = dic[@"call"];

    [self.printerSeariesID print:@[@{@"content":@"打印第1行",@"LayoutStyle":@"left"},
                                   @{@"content":@"打印第2行",@"LayoutStyle":@"center"},
                                   @{@"content":@"打印空格",@"LayoutStyle":@"enter"},
                                   @{@"content":@"打印第3行",@"LayoutStyle":@"right"},
                                   @{@"content":@"打印第4行",@"LayoutStyle":@"left"}]];
    self.printerSeariesID.printResult_block = ^(NSString *aStrResult) {
        [weakself showText:[NSString stringWithFormat:@"打印结果：%@",aStrResult]];
        fluresult(aStrResult);
    };

}

#pragma mark - 判断蓝牙是否打开
- (void)printer_bluetoothIsOpened:(id)aObject{
    
    NSDictionary *dic = (NSDictionary *)aObject;
    FlutterResult fluresult = dic[@"result"];

    [self.printerSeariesID bluetoothIsOpen];
    self.printerSeariesID.bluetoothIsOpenResult_block = ^(NSString *aStrResult) {
        fluresult(aStrResult);
    };

}

#pragma mark -

- (void)showText:(NSString *)aText {
    
    UIAlertView *alertView = [[UIAlertView alloc]initWithTitle:@"提示" message:aText delegate:self cancelButtonTitle:@"好的" otherButtonTitles:nil];
    alertView.alertViewStyle = UIAlertViewStyleDefault;
    [alertView show];
    
}



@end
